<script lang="ts">
import Vue from 'vue';

export default Vue.extend({
  props: {
    animationName: {
      type: String,
      required: false,
      default: 'fade',
    },
  },
  data() {
    return {
      animate: false,
    };
  },
  mounted() {
    this.animationHandler();
  },
  methods: {
    animationHandler() {
      const { target } = this.$refs;
      const observer = new IntersectionObserver(
        ([entry]) => {
          if (entry.isIntersecting) {
            this.animate = true;
          }
        },
        {
          threshold: 0,
        },
      );
      observer.observe(target);
    },
  },
});
</script>

<template>
  <div ref="target">
    <transition :name="animationName">
      <div v-show="animate">
        <slot />
      </div>
    </transition>
  </div>
</template>
